"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const path_1 = require("path");
const fs = require("fs");
async function splitOption(input, output, partSize) {
    const istream = fs.createReadStream(input);
    let ostream;
    let sum = 0;
    let id = 0;
    istream.on('readable', () => {
        // const ofile = output.replace('%d', id + '')
        // const ostream = fs.createWriteStream(ofile)
        let len = istream.readableLength;
        if (sum + len > partSize) {
            len -= partSize - sum;
            // ostream.end()
        }
        function flush() {
            const chunk = istream.read();
            ostream.write(chunk, err => {
                if (err) {
                    console.error(err.message);
                }
                else {
                    flush();
                }
            });
        }
        flush();
    });
    // const fd = fs.openSync(input, 'r')
    // const buf = Buffer.allocUnsafe(1024 * 1024)
    // let pos = 0
    // let id = 0
    // for (;;) {
    //   for (let i = 0; i < size; i++) {
    //     fs.readSync(fd, buf, {position: pos})
    //     pos += buf.length
    //     const ofile = output.replace('%d', i + '')
    //     fs.writeFileSync(ofile, buf)
    //   }
    //   i++
    // }
    // fs.closeSync(fd)
}
async function run(args, program) {
    const { input, output } = args.input;
    const size = +args.size;
    if (!input || !(size > 0)) {
        program.outputHelp();
        return;
    }
    splitOption(input, output || (0, path_1.basename)(input) + '-%d.fcpart', size * 1024 * 1024);
}
exports.run = run;
//# sourceMappingURL=cmd-split.js.map